gtkmm: Gtk::Printer Class Reference

gtkmm 2.24.4

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::Printer Class Reference
Printing

A Printer object represents a printer. More...

Inheritance diagram for Gtk::Printer:
[legend]
Collaboration diagram for Gtk::Printer:
[legend]

## Public Member Functions
| Printer (Printer&& src) noexcept
Printer& | operator= (Printer&& src) noexcept
| ~Printer () noexceptoverride
GtkPrinter* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkPrinter* | gobj () const
| Provides access to the underlying C GObject. More...
GtkPrinter* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
bool | equal (const Glib::RefPtr< Printer >& other) const
Glib::ustring | get_name () const
| Returns the name of the printer. More...
Glib::ustring | get_state_message () const
| Returns the state message describing the current state of the printer. More...
Glib::ustring | get_description () const
| Gets the description of the printer. More...
Glib::ustring | get_location () const
| Returns a description of the location of the printer. More...
Glib::ustring | get_icon_name () const
| Gets the name of the icon to use for the printer. More...
int | get_job_count () const
| Gets the number of jobs currently queued on the printer. More...
bool | is_active () const
| Returns whether the printer is currently active (i.e. accepts new jobs). More...
bool | is_paused () const
| Returns whether the printer is currently paused. More...
bool | is_accepting_jobs () const
| Returns whether the printer is accepting jobs. More...
bool | is_virtual () const
| Returns whether the printer is virtual (i.e. does not represent actual printer hardware, but something like a CUPS class). More...
bool | is_default () const
| Returns whether the printer is the default printer. More...
bool | accepts_pdf () const
| Returns whether the printer accepts input in PDF format. More...
bool | accepts_ps () const
| Returns whether the printer accepts input in PostScript format. More...
Glib::ListHandle< Glib::RefPtr< PageSetup > > | list_papers ()
| Lists all the paper sizes printer supports. More...
Glib::RefPtr< PageSetup > | get_default_page_size () const
| Returns default page size of printer. More...
Glib::ListHandle< Glib::RefPtr< const PageSetup > > | list_papers () const
| Lists all the paper sizes printer supports. More...
bool | has_details () const
| Returns whether the printer details are available. More...
void | request_details ()
| Requests the printer details. More...
PrintCapabilities | get_capabilities () const
| Returns the printer's capabilities. More...
bool | get_hard_margins (double& top, double& bottom, double&left, double&right) const
| Retrieve the hard margins of printer, i.e. the margins that define the area at the borders of the paper that the printer cannot print to. More...
Glib::SignalProxy< void, bool > | signal_details_acquired ()
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| Name of the printer. More...
Glib::PropertyProxy_ReadOnly< bool > | property_is_virtual () const
| FALSE if this represents a real hardware printer. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_state_message () const
| String giving the current state of the printer. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_location () const
| The location of the printer. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_icon_name () const
| The icon name to use for the printer. More...
Glib::PropertyProxy_ReadOnly< int > | property_job_count () const
| Number of jobs queued in the printer. More...
Glib::PropertyProxy_ReadOnly< bool > | property_accepts_pdf () const
| TRUE if this printer can accept PDF. More...
Glib::PropertyProxy_ReadOnly< bool > | property_accepts_ps () const
| TRUE if this printer can accept PostScript. More...
Glib::PropertyProxy_ReadOnly< bool > | property_paused () const
| TRUE if this printer is paused. More...
Glib::PropertyProxy_ReadOnly< bool > | property_accepting_jobs () const
| TRUE if this printer is accepting new jobs. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void > &&slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, sigc::slot< void > &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
virtual void | on_details_acquired (bool success)
| This is a default handler for the signal signal_details_acquired(). More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexceptoverride
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions
(Note that these are not member functions.)
typedef sigc::slot< bool, const Glib::RefPtr< Printer >& > | SlotPrinterEnumerator
| For example, bool on_enumerate_printers(const Glib::RefPtr<Printer>& printer);. More...
bool | operator== (const Glib::RefPtr< Printer >& lhs, const Glib::RefPtr< Printer >& rhs)
bool | operator!= (const Glib::RefPtr< Printer >& lhs, const Glib::RefPtr< Printer >& rhs)
void | enumerate_printers (const SlotPrinterEnumerator& slot, bool wait=true)
| Calls a function for all Printers. More...
Glib::RefPtr< Gtk::Printer > | wrap (GtkPrinter* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

A Printer object represents a printer.

You only need to deal directly with printers if you use the non-portable PrintUnixDialog API.

A Printer object allows to get status information about the printer, such as its description, its location, the number of queued jobs, etc. Most importantly, a Printer object can be used to create a PrintJob object, which lets you print to the printer.

Since gtkmm 2.10:

## Constructor & Destructor Documentation

Gtk::Printer::Printer | ( | Printer&& | src | ) |
| noexcept

Gtk::Printer::~Printer | ( |  | ) |
| overridenoexcept

## Member Function Documentation

bool Gtk::Printer::accepts_pdf | ( |  | ) | const

Returns whether the printer accepts input in PDF format.

Since gtkmm 2.10:

Returns
  `true` if printer accepts PDF.

bool Gtk::Printer::accepts_ps | ( |  | ) | const

Returns whether the printer accepts input in PostScript format.

Since gtkmm 2.10:

Returns
  `true` if printer accepts PostScript.

bool Gtk::Printer::equal | ( | const Glib::RefPtr< Printer >& | other | ) | const

PrintCapabilities Gtk::Printer::get_capabilities | ( |  | ) | const

Returns the printer's capabilities.

This is useful when you're using Gtk::PrintUnixDialog's manual-capabilities setting and need to know which settings the printer can handle and which you must handle yourself.

This will return 0 unless the printer's details are available, see has_details() and request_details().

Since gtkmm 2.12:

Returns
  The printer's capabilities.

Glib::RefPtr<PageSetup> Gtk::Printer::get_default_page_size | ( |  | ) | const

Returns default page size of printer.

Since gtkmm 2.14:

Returns
  A newly allocated Gtk::PageSetup with default page size of the printer.

Glib::ustring Gtk::Printer::get_description | ( |  | ) | const

Gets the description of the printer.

Since gtkmm 2.10:

Returns
  The description of printer.

bool Gtk::Printer::get_hard_margins | ( | double & | top,
|  | double & | bottom,
|  | double & | left,
|  | double & | right
| ) |  | const

Retrieve the hard margins of printer, i.e. the margins that define the area at the borders of the paper that the printer cannot print to.

Note
  This will not succeed unless the printer's details are available, see has_details() and request_details().

Since gtkmm 2.20:

Parameters

  top | A location to store the top margin in.
  bottom | A location to store the bottom margin in.
  left | A location to store the left margin in.
  right | A location to store the right margin in.

Returns
  `true` iff the hard margins were retrieved.

Glib::ustring Gtk::Printer::get_icon_name | ( |  | ) | const

Gets the name of the icon to use for the printer.

Since gtkmm 2.10:

Returns
  The icon name for printer.

int Gtk::Printer::get_job_count | ( |  | ) | const

Gets the number of jobs currently queued on the printer.

Since gtkmm 2.10:

Returns
  The number of jobs on printer.

Glib::ustring Gtk::Printer::get_location | ( |  | ) | const

Returns a description of the location of the printer.

Since gtkmm 2.10:

Returns
  The location of printer.

Glib::ustring Gtk::Printer::get_name | ( |  | ) | const

Returns the name of the printer.

Since gtkmm 2.10:

Returns
  The name of printer.

Glib::ustring Gtk::Printer::get_state_message | ( |  | ) | const

Returns the state message describing the current state of the printer.

Since gtkmm 2.10:

Returns
  The state message of printer.

static GType Gtk::Printer::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GtkPrinter* Gtk::Printer::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GtkPrinter* Gtk::Printer::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

GtkPrinter* Gtk::Printer::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

bool Gtk::Printer::has_details | ( |  | ) | const

Returns whether the printer details are available.

Since gtkmm 2.12:

Returns
  `true` if printer details are available.

bool Gtk::Printer::is_accepting_jobs | ( |  | ) | const

Returns whether the printer is accepting jobs.

Since gtkmm 2.14:

Returns
  `true` if printer is accepting jobs.

bool Gtk::Printer::is_active | ( |  | ) | const

Returns whether the printer is currently active (i.e. accepts new jobs).

Since gtkmm 2.10:

Returns
  `true` if printer is active.

bool Gtk::Printer::is_default | ( |  | ) | const

Returns whether the printer is the default printer.

Since gtkmm 2.10:

Returns
  `true` if printer is the default.

bool Gtk::Printer::is_paused | ( |  | ) | const

Returns whether the printer is currently paused.

A paused printer still accepts jobs, but it is not printing them.

Since gtkmm 2.14:

Returns
  `true` if printer is paused.

bool Gtk::Printer::is_virtual | ( |  | ) | const

Returns whether the printer is virtual (i.e. does not represent actual printer hardware, but something like a CUPS class).

Since gtkmm 2.10:

Returns
  `true` if printer is virtual.

Glib::ListHandle< Glib::RefPtr<PageSetup> > Gtk::Printer::list_papers | ( |  | ) |

Lists all the paper sizes printer supports.

This will return and empty list unless the printer's details are available, see has_details() and request_details().

Since gtkmm 2.12:

Returns
  A newly allocated list of newly allocated Gtk::PageSetup s.

Glib::ListHandle< Glib::RefPtr<const PageSetup> > Gtk::Printer::list_papers | ( |  | ) | const

Lists all the paper sizes printer supports.

This will return and empty list unless the printer's details are available, see has_details() and request_details().

Since gtkmm 2.12:

Returns
  A newly allocated list of newly allocated Gtk::PageSetup s.

virtual void Gtk::Printer::on_details_acquired | ( | bool | success | ) |
| protectedvirtual

This is a default handler for the signal signal_details_acquired().

Printer& Gtk::Printer::operator= | ( | Printer&& | src | ) |
| noexcept

Glib::PropertyProxy_ReadOnly< bool > Gtk::Printer::property_accepting_jobs | ( |  | ) | const

TRUE if this printer is accepting new jobs.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Printer::property_accepts_pdf | ( |  | ) | const

TRUE if this printer can accept PDF.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Printer::property_accepts_ps | ( |  | ) | const

TRUE if this printer can accept PostScript.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::Printer::property_icon_name | ( |  | ) | const

The icon name to use for the printer.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Printer::property_is_virtual | ( |  | ) | const

FALSE if this represents a real hardware printer.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< int > Gtk::Printer::property_job_count | ( |  | ) | const

Number of jobs queued in the printer.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::Printer::property_location | ( |  | ) | const

The location of the printer.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::Printer::property_name | ( |  | ) | const

Name of the printer.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Printer::property_paused | ( |  | ) | const

TRUE if this printer is paused.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::Printer::property_state_message | ( |  | ) | const

String giving the current state of the printer.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

void Gtk::Printer::request_details | ( |  | ) |

Requests the printer details.

When the details are available, the details_acquired signal will be emitted.

Since gtkmm 2.12:

Glib::SignalProxy< void,bool > Gtk::Printer::signal_details_acquired | ( |  | ) |

Slot Prototype:
  `void on_my_details_acquired(bool success)`

## Friends And Related Function Documentation

void enumerate_printers | ( | const SlotPrinterEnumerator& | slot,
|  | bool | wait = `true`
| ) |  |
| related

Calls a function for all Printers.

If the callback returns true, the enumeration is stopped. A function to call for each printer wait If true, wait in a recursive mainloop until all printers are enumerated; otherwise return early.

bool operator!= | ( | const Glib::RefPtr< Printer >& | lhs,
|  | const Glib::RefPtr< Printer >& | rhs
| ) |  |
| related

bool operator== | ( | const Glib::RefPtr< Printer >& | lhs,
|  | const Glib::RefPtr< Printer >& | rhs
| ) |  |
| related

typedef sigc::slot< bool, const Glib::RefPtr<Printer>& > SlotPrinterEnumerator
| related

For example, bool on_enumerate_printers(const Glib::RefPtr<Printer>& printer);.

Parameters

  printer | A printer.
  result | true to stop the enumeration, false to continue.

Glib::RefPtr< Gtk::Printer > wrap | ( | GtkPrinter * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gtkmm/printer.h